package database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import global.GlobalData;
import global.GlobalData.TipoRegion;

public class JerarquiaRegiones {

	public static void main/*crearJerarquia*/( String args[] ) throws InterruptedException {
		
		Connection conn = null;
	
		try
		{
			 //----------  CONEXION A LA BD  ----------------
			
	         Class.forName("com.mysql.jdbc.Driver");
	         
	         //TODO controlar acceso identificado
	         conn = DriverManager.getConnection(GlobalData.url,GlobalData.login,GlobalData.password);
	
	         if (conn == null)
	         {
	            System.out.println("Conexin a base de datos "+GlobalData.url+" ... falhida");
	         }
	         
	         //---  EJECUCION DE BORRADO Y CREACION DE TABLAS  -----
	         try{
	             Statement st = conn.createStatement();
	             
	             //------  BORRADO  --------------
	             
	             //drop preexistent tables
	             st.executeUpdate("DROP TABLE goodwave.municipios");
	             st.executeUpdate("DROP TABLE goodwave.provincias");
	             st.executeUpdate("DROP TABLE goodwave.ccaa");
	             st.executeUpdate("DROP TABLE goodwave.paises");

	             //------  CREACION  -------------

	             //TODO que hacer con CEUTA y MELILLA???
	             //TODO controlar valores UNIQUE de nombres
	             //TODO controlar REFERENCES
	             //TODO controlar los distintos nombres de las provincias
	             //TODO posible solucion, clave primaria conjunta de ID y nombre.
	             
	             //Create table paises
	             String table = ("CREATE TABLE `paises` (" +
	       			  "`PaisId` int(11) NOT NULL PRIMARY KEY AUTO_INCREMENT," +
	       			  "`PaisNombre` varchar(40) NOT NULL) TYPE = INNODB");
	             st.executeUpdate(table);
	             System.out.println("Creacion de la tabla 'paises': OK");
	             
	             //Create table ccaa
	             table = ("CREATE TABLE `ccaa` (" +
	       			  "`CAId` int(11) NOT NULL PRIMARY KEY AUTO_INCREMENT," +
	       			  "`CANombre` varchar(40) NOT NULL," +
	       			  "`codPais` int(11) NOT NULL," +
	       			  "FOREIGN KEY(codPais) REFERENCES paises(paisId)" +
	       			  ") TYPE = INNODB");
	             st.executeUpdate(table);
	             System.out.println("Creacion de la tabla 'ccaa': OK");
	             
	             //create table provincias
	             table = ("CREATE TABLE `provincias` (" +
				  "`provinciaId` int(11) NOT NULL PRIMARY KEY AUTO_INCREMENT," +
				  "`provinciaNombre` varchar(40) NOT NULL," +
				  "`codCA` int(11) NOT NULL," +
				  "FOREIGN KEY(codCA) REFERENCES ccaa(caId)" +
				  ") TYPE = INNODB");
	             st.executeUpdate(table);
	             System.out.println("Creacion de la tabla 'provincias': OK");
	             
	             //create table municipios
	             table = ("CREATE TABLE `municipios` (" + 
				  "`municipioId` int(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, " +
				  "`municipioNombre` varchar(40) NOT NULL," +
				  "`codProv` int(11) NOT NULL," +
				  "FOREIGN KEY(codProv) REFERENCES provincias(provinciaId)" +
				  ") TYPE = INNODB");
	             st.executeUpdate(table);
	             System.out.println("Creacion de la tabla 'municipios': OK");
	             
	             System.out.println("Proceso de creacion de tablas terminado con exito!");
		             
	           }
	           catch(SQLException s){
	             System.out.println(s);
	         }
	
	         conn.close();
	         
	         //------- FIN CONEXION A LA BD  ----------------
	      }
		  catch(SQLException ex)
		  {
		     System.out.println(ex);
		  }
		  catch(ClassNotFoundException ex)
		  {
		     System.out.println(ex);
		  }
	}
	
	//la estructura ser: 	vector[0] = Region_mas_alta_en_la_jeraquia
	//						vector[1-X] = Regiones_mas_bajar_pertencientes_a_la_mas_alta
	//por ejemplo: vector = {Almeria Abla Antas Arboleas .... Zurgena}
	public static void rellenarDatosJerarquia( String regiones[], TipoRegion tipo  ) throws InterruptedException {
	
		Connection conn = null;
		String consulta = null, consulta2 = null;
		Statement st = null;
		ResultSet res = null;
		int codReg = -1;
		
		try
		{
			 //----------CONEXION A LA BD----------------
			
	         Class.forName("com.mysql.jdbc.Driver");
	         
	         //TODO controlar acceso identificado
	         conn = DriverManager.getConnection(GlobalData.url,GlobalData.login,GlobalData.password);
	
	         if (conn == null)
	         {
	            System.out.println("Conexin a base de datos "+GlobalData.url+" ... falhida");
	         }
	         
	 		//---------  EJECUCION DE RELLENO DE DATOS  ---------
	         
	        try{

		 		//TODO controlar los errores en todos los mtodos y hacer clase "error"
		 		switch (tipo){
		 		case pais:
		 			
		 			st = conn.createStatement();
		 			
		 			//-----  VEMOS SI YA EXISTE EL PAIS  -------------
		            res  = st.executeQuery("SELECT COUNT(*) FROM `paises` " + 
			   				  "WHERE paisNombre = '" + regiones[0] + "'");
			             
		            res.next();
		            if (Integer.parseInt(res.getString("Count(*)")) == 0){	//Si no existe el pais
		            	//TODO controlar el error porque no existe el pais
		            }
		            else{	//si el pais no existe
		            	
			 			//-----  INSERTAMOS EL PAIS  -------------
			 			consulta = ("INSERT INTO paises (paisNombre)" +
			 					"VALUES ('" + regiones[0] + "')");
			 			
			 			st.executeUpdate(consulta);
			 			
			 			//-------  BUSCAMOS EL CDIGO DEL PAIS  --------
			            res  = st.executeQuery("SELECT paisID FROM `paises` " + 
				   				  "WHERE paisNombre = '" + regiones[0] + "'");
				             
				        res.next();
				        codReg = res.getInt("paisID");
				        
				        //------  INSERTAMOS LAS CCAA  --------------
			 			for (int i=1; i<regiones.length; i++){
				 			consulta2 = ("INSERT INTO ccaa (caNombre, codPais)" +
				 					"VALUES ('" + regiones[i] + "'," + codReg + ")");
				 			st.executeUpdate(consulta2);
			 			}
			 			
			 			System.out.println("Relleno de las tablas 'paises' y 'ccaa': OK");
		            }
		 			break;
		 			
		 		case ca:
		 			
		 			st = conn.createStatement();
		 			
		 			//TODO esto se hace automatico con REFERENCES en la creacion de la tabla??
		 			//-----  VEMOS SI EXISTE LA CA  -------------
		            res  = st.executeQuery("SELECT COUNT(*) FROM `ccaa` " + 
			   				  "WHERE caNombre = '" + regiones[0] + "'");
			             
		            res.next();
		            if (Integer.parseInt(res.getString("Count(*)")) == 0){	//Si no existe la CA
		            	//TODO controlar el error porque no existe la CA
		            }
		            else{	//si la CA no existe
		            	
		            	//-----  INSERTAMOS LA CA  -------------
			 			consulta = ("INSERT INTO ccaa (caNombre)" +
			 					"VALUES ('" + regiones[0] + "')");
			 			
			 			st.executeUpdate(consulta);
			 			
			 			//-------  BUSCAMOS EL CDIGO DE LA CA  --------
			            res  = st.executeQuery("SELECT caID FROM `ccaa` " + 
				   				  "WHERE caNombre = '" + regiones[0] + "'");
				             
				        res.next();
				        codReg = res.getInt("caID");
				        
				        //------  INSERTAMOS LAS PROVINCIAS  --------------
			 			for (int i=1; i<regiones.length; i++){
				 			consulta2 = ("INSERT INTO provincias (provinciaNombre, codCA)" +
				 					"VALUES ('" + regiones[i] + "'," + codReg + ")");
				 			st.executeUpdate(consulta2);
			 			}
			 			
			 			System.out.println("Relleno de las tablas 'ccaa' y 'provincias': OK");
		            }
		 			break;
		 			
		 		case provincia:
		 			
		 			st = conn.createStatement();
		 			
		 			//-----  VEMOS SI EXISTE LA PROVINCIA  -------------
		            res  = st.executeQuery("SELECT COUNT(*) FROM `provincias` " + 
			   				  "WHERE provinciaNombre = '" + regiones[0] + "'");
			             
		            res.next();
		            if (Integer.parseInt(res.getString("Count(*)")) == 0){	//Si no existe la provincia
		            	//TODO controlar el error porque no existe la provincia
		            }
		            else{	//si la provincia no existe
		            	
		            	//-----  INSERTAMOS LA PROVINCIA  -------------
			 			consulta = ("INSERT INTO provincias (provinciaNombre)" +
			 					"VALUES ('" + regiones[0] + "')");
			 			
			 			st.executeUpdate(consulta);
			 			
			 			//-------  BUSCAMOS EL CDIGO DE LA PROVINCIA  --------
			            res  = st.executeQuery("SELECT provinciaID FROM `provincias` " + 
				   				  "WHERE provinciaNombre = '" + regiones[0] + "'");
				             
				        res.next();
				        codReg = res.getInt("provinciaID");
				        
				        //------  INSERTAMOS LOS MUNICIPIOS  --------------
			 			for (int i=1; i<regiones.length; i++){
				 			consulta2 = ("INSERT INTO municipios (municipioNombre, codprov)" +
				 					"VALUES ('" + regiones[i] + "'," + codReg + ")");
				 			st.executeUpdate(consulta2);
			 			}
			 			
			 			System.out.println("Relleno de las tablas 'provincias' y 'municipios': OK");
		            }
		 			break;
		 			
		 		case municipio:
		 			//TODO error porque en la jerarquia no hay nada por debajo de municipio
		 			break;
		 		}         
	        }
	        catch(SQLException s){
	        	System.out.println(s);
	        }
	
	         conn.close();
	         
	         //------- FIN CONEXION A LA BD  ----------------
	      }
		  catch(SQLException ex)
		  {
		     System.out.println(ex);
		  }
		  catch(ClassNotFoundException ex)
		  {
		     System.out.println(ex);
		  }
	}
}
